WATCH(1)

NOM
watch - Exécuter un programme périodiquement en affichant le résultat à l'écran

SYNOPSIS
watch [options] commande

DESCRIPTION
watch exécute la commande périodiquement et affiche le résultat et les erreurs (en plein écran). Cela permet d'observer les changements de résultats du programme au fil du temps. Par défaut, le programme est exécuté toutes les deux secondes. Par défaut, watch fonctionnera jusqu'à être interrompu.

OPTIONS

-d, --differences [permanent]
    Surligner les différences entre les mises à jour successives. L'option lira un argument facultatif qui modifie la surbrillance de façon permanente, permettant de voir ce qui a été modifié au moins une fois depuis la première itération.

-n, --interval intervalle
    Indiquer l'intervalle de mise à jour, en seconde. La commande ne permet pas d'utiliser un intervalle plus rapide que 0,1 seconde, qui est la valeur utilisée à la place des valeurs plus petites.

-p, --precise
    Essayer d'exécuter commande toutes les intervalle secondes. Essayez avec ntptime et regardez comme les fractions de seconde ne changent quasiment pas, contrairement au mode normal où elles augmentent continuellement.

-t, --no-title
    Cacher l'en-tête contenant l'intervalle, la commande et la date actuelle en haut de l'affichage, ainsi que la ligne blanche qui suit.

-b, --beep
    Émettre un bip lorsque le code de retour de la commande est non nul.

-e, --errexit
    Geler les mises à jour en cas d'erreur de la commande et quitter après avoir appuyé sur une touche.

-g, --chgexit
    Terminer quand la sortie de commande est modifiée.

-c, --color
    Interpréter les suites et style de couleur ANSI.

-x, --exec
    commande est passée en paramètre à sh -c, ce qui signifie que vous devrez parfois utiliser des guillemets supplémentaires pour obtenir l'effet désiré. Ce comportement peut être modifié avec l'option --exec qui passe la commande à exec(2).

-h, --help
    Afficher l'aide et quitter.

-v, --version
    Afficher la version du logiciel et quitter.

NOTES
La reconnaissance des options suit la norme POSIX (le traitement des options s'arrête dès le premier paramètre qui n'est pas une option). Cela signifie que les options se trouvant après la commande ne seront pas interprétées par watch.

EXEMPLES

Pour vérifier les courriels :

    watch -n 60 from

Pour afficher les changements dans le contenu d'un répertoire :

    watch -d ls -l

Pour n'afficher que les fichiers appartenant à arthur :

    watch -d 'ls -l | fgrep arthur'

Pour vérifier l'effet des guillemets :

    watch echo $$
    watch echo '$$'
    watch echo "'"'$$'"'"

Pour vérifier l'effet du temps de maintien de la précision, essayez en ajoutant -p à

    watch -n 10 sleep 1

Pour vérifier que l'administrateur a installé le dernier noyau avec

    watch uname -r

Notez que -p peut ne pas fonctionner entre deux redémarrages, à cause de ntpdate ou d'autres programmes modifiant la date au démarrage.

BOGUES
Lors du redimensionnement d'un terminal, l'écran ne sera pas rafraîchi correctement avant la prochaine exécution. Les mises en évidence dues à --differences sont également perdues.

Les caractères non imprimables de la sortie du programme sont ignorés. Utilisez « cat -v » pour les afficher.

La combinaison de caractères supposés s'afficher en dernière colonne de l'écran risque de s'afficher dans la colonne précédente ou pas du tout.

Les combinaisons de caractères ne sont jamais considérées différentes en mode --differences. Seul le caractère de base est considéré.

Les lignes blanches qui suivent directement une ligne s'arrêtant en dernière colonne ne sont pas affichées

Le mode --precise ne dispose pas encore de fonctions de temporisation pour compenser une commande dont le temps d'exécution est supérieure à secondes secondes. watch peut également lancer en rafales autant d'exécution de commande que possible pour rattraper une exécution précédente qui aurait pris plus de secondes secondes à s'exécuter (par exemple, netstat prend beaucoup de temps pour effectuer une interrogation DNS).

CODES DE RETOUR

    0   Réussite.
    1   Erreurs diverses.
    2   Échec lors du dédoublement (« fork ») du processus à observer.
    3   Échec de remplacement de la sortie standard du processus fils par une écriture vers le tube.
    4   Échec d'exécution de la commande.
    5   Échec de la fermeture d'écriture vers le tube du processus fils.
    7   Échec de la création du tube IPC.
    8   Le processus fils n'a pas pu renvoyer une valeur avec waitpid(2) ou la commande s'est terminée en erreur.
    autre
        L'observation propagera l'état du code de retour en tant que code de retour du fils.

AUTEURS
Le programme watch a été écrit par Tony Rems <rembo@unisoft.com> en 1991 avec des corrections et des modifications de François Pinard. Mike Coleman <mkc@acm.org> l'a retravaillé et a ajouté de nouvelles fonctionnalités en 1999. Les fonctionnalités beep, exec et la gestion d'erreurs ont été ajoutés par Morty Abzug <morty@frakir.org> en 2008. Un matin de mars de 2003, Anthony DeRobertis <asd@suespammers.org> a ajouté la gestion de la précision à la milliseconde. La prise en charge d'Unicode a été ajoutée en 2009 par Jarrod Lowe <procps@rrod.net>.